#include <fstream>
#include <algorithm>
using namespace std;

const int NMAX = 2e6 + 1;
const int MOD = 666013, FACTOR1 = 17, FACTOR2 = 35;

int vis[NMAX], arr[NMAX], n, cnt;

ifstream fin("aranjare.in");
ofstream fout("aranjare.out");

int main()
{
    fin >> n;
    fin >> arr[1] >> arr[2];
    for (int i = 3; i <= n; ++i)
        arr[i] = (1LL * arr[i - 2] * FACTOR1 + 1LL * arr[i - 1] * FACTOR2) % MOD + 3;

    sort(arr + 1, arr + n + 1);

    for (int i = 1; i <= n; ++i)
        if (!vis[i])
        {
            for (int j = 1; j <= n; ++j)
                if (arr[j] % arr[i] == 0)
                    vis[j] = 1;
            cnt++;
        }
    fout << cnt << '\n';
    return 0;
}
