#include <fstream>
#include <algorithm>
using namespace std;

const int NMAX = 2e6 + 1;
const int MOD = 666013, FACTOR1 = 17, FACTOR2 = 35;

int gr[MOD + 5], a[NMAX], n, cnt;

ifstream fin("aranjare.in");
ofstream fout("aranjare.out");

int main()
{
    fin >> n;
    fin >> a[1] >> a[2];
    for (int i = 3; i <= n; ++i)
        a[i] = (1LL * a[i - 2] * FACTOR1 + 1LL * a[i - 1] * FACTOR2) % MOD + 3;

    sort(a + 1, a + n + 1);

    for (int i = 1; i <= n; ++i)
        if (gr[a[i]] == 0)
        {
            ++cnt;
            for (int j = a[i]; j <= a[n]; j += a[i])
                gr[j] = cnt;
        }
    fout << cnt << '\n';
    return 0;
}
